Index: /palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_2d.f90	(revision 1326)
+++ /palm/trunk/SOURCE/data_output_2d.f90	(revision 1327)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! parts concerning iso2d output removed,
+! -netcdf output queries
 !
 ! Former revisions:
@@ -101,6 +102,6 @@
                do2d_xz_last_time, do2d_xz_n, do2d_xz_time_count,               &
                do2d_yz_last_time, do2d_yz_n, do2d_yz_time_count,               &
-               ibc_uv_b, icloud_scheme, io_blocks, io_group, iso2d_output,     &
-               message_string, netcdf_data_format, netcdf_output,              &
+               ibc_uv_b, icloud_scheme, io_blocks, io_group,                   &
+               message_string, netcdf_data_format,                             &
                ntdim_2d_xy, ntdim_2d_xz, ntdim_2d_yz, psolver, section,        &
                simulated_time,  simulated_time_chr, time_since_reference_point
@@ -236,6 +237,5 @@
 !
 !--       Parallel netCDF4/HDF5 output is done on all PEs, all other on PE0 only
-          IF ( netcdf_output .AND. ( myid == 0 .OR. netcdf_data_format > 4 ) ) &
-          THEN
+          IF ( myid == 0  .OR.  netcdf_data_format > 4 )  THEN
              CALL check_open( 101+av*10 )
           ENDIF
@@ -245,5 +245,4 @@
           ELSE
              IF ( myid == 0 )  THEN
-                IF ( iso2d_output )  CALL check_open( 21 )
 #if defined( __parallel )
                 ALLOCATE( total_2d(-nbgp:nx+nbgp,-nbgp:ny+nbgp) )
@@ -269,6 +268,5 @@
 !
 !--       Parallel netCDF4/HDF5 output is done on all PEs, all other on PE0 only
-          IF ( netcdf_output .AND. ( myid == 0 .OR. netcdf_data_format > 4 ) ) &
-          THEN
+          IF ( myid == 0 .OR. netcdf_data_format > 4 )  THEN
              CALL check_open( 102+av*10 )
           ENDIF
@@ -278,5 +276,4 @@
           ELSE
              IF ( myid == 0 )  THEN
-                IF ( iso2d_output )  CALL check_open( 22 )
 #if defined( __parallel )
                 ALLOCATE( total_2d(-nbgp:nx+nbgp,nzb:nzt+1) )
@@ -302,6 +299,5 @@
 !
 !--       Parallel netCDF4/HDF5 output is done on all PEs, all other on PE0 only
-          IF ( netcdf_output .AND. ( myid == 0 .OR. netcdf_data_format > 4 ) ) &
-          THEN
+          IF ( myid == 0 .OR. netcdf_data_format > 4 )  THEN
              CALL check_open( 103+av*10 )
           ENDIF
@@ -311,5 +307,4 @@
           ELSE
              IF ( myid == 0 )  THEN
-                IF ( iso2d_output )  CALL check_open( 23 )
 #if defined( __parallel )
                 ALLOCATE( total_2d(-nbgp:ny+nbgp,nzb:nzt+1) )
@@ -882,6 +877,6 @@
                       do2d_xy_last_time(av)  = simulated_time
                       IF ( myid == 0 )  THEN
-                         IF ( ( .NOT. data_output_2d_on_each_pe  .AND.         &
-                              netcdf_output )  .OR.  netcdf_data_format > 4 )  &
+                         IF ( .NOT. data_output_2d_on_each_pe  &
+                              .OR.  netcdf_data_format > 4 )   &
                          THEN
 #if defined( __netcdf )
@@ -921,5 +916,5 @@
 
 #if defined( __parallel )
-                   IF ( netcdf_output  .AND.  netcdf_data_format > 4 )  THEN
+                   IF ( netcdf_data_format > 4 )  THEN
 !
 !--                   Parallel output in netCDF4/HDF5 format.
@@ -947,5 +942,5 @@
 !--                      Output of partial arrays on each PE
 #if defined( __netcdf )
-                         IF ( netcdf_output  .AND.  myid == 0 )  THEN
+                         IF ( myid == 0 )  THEN
                             WRITE ( 21 )  time_since_reference_point,          &
                                           do2d_xy_time_count(av), av
@@ -994,9 +989,4 @@
                             ENDDO
 !
-!--                         Output of the total cross-section.
-                            IF ( iso2d_output )  THEN
-                               WRITE (21)  total_2d(-nbgp:nx+nbgp,-nbgp:ny+nbgp)
-                            ENDIF
-!
 !--                         Relocate the local array for the next loop increment
                             DEALLOCATE( local_2d )
@@ -1004,20 +994,18 @@
 
 #if defined( __netcdf )
-                            IF ( netcdf_output )  THEN
-                               IF ( two_d ) THEN
-                                  nc_stat = NF90_PUT_VAR( id_set_xy(av),       &
-                                                          id_var_do2d(av,if),  &
-                                                      total_2d(0:nx+1,0:ny+1), &
-                                start = (/ 1, 1, 1, do2d_xy_time_count(av) /), &
-                                                count = (/ nx+2, ny+2, 1, 1 /) )
-                               ELSE
-                                  nc_stat = NF90_PUT_VAR( id_set_xy(av),       &
-                                                          id_var_do2d(av,if),  &
-                                                      total_2d(0:nx+1,0:ny+1), &
-                               start = (/ 1, 1, is, do2d_xy_time_count(av) /), &
-                                                count = (/ nx+2, ny+2, 1, 1 /) )
-                               ENDIF
-                               CALL handle_netcdf_error( 'data_output_2d', 54 )
+                            IF ( two_d ) THEN
+                               nc_stat = NF90_PUT_VAR( id_set_xy(av),       &
+                                                       id_var_do2d(av,if),  &
+                                                   total_2d(0:nx+1,0:ny+1), &
+                             start = (/ 1, 1, 1, do2d_xy_time_count(av) /), &
+                                             count = (/ nx+2, ny+2, 1, 1 /) )
+                            ELSE
+                               nc_stat = NF90_PUT_VAR( id_set_xy(av),       &
+                                                       id_var_do2d(av,if),  &
+                                                   total_2d(0:nx+1,0:ny+1), &
+                            start = (/ 1, 1, is, do2d_xy_time_count(av) /), &
+                                             count = (/ nx+2, ny+2, 1, 1 /) )
                             ENDIF
+                            CALL handle_netcdf_error( 'data_output_2d', 54 )
 #endif
 
@@ -1043,48 +1031,22 @@
                    ENDIF
 #else
-                   IF ( iso2d_output )  THEN
-                      WRITE (21)  local_2d(nxl:nxr+1,nys:nyn+1)
+#if defined( __netcdf )
+                   IF ( two_d ) THEN
+                      nc_stat = NF90_PUT_VAR( id_set_xy(av),                &
+                                              id_var_do2d(av,if),           &
+                                             local_2d(nxl:nxr+1,nys:nyn+1), &
+                             start = (/ 1, 1, 1, do2d_xy_time_count(av) /), &
+                                           count = (/ nx+2, ny+2, 1, 1 /) )
+                   ELSE
+                      nc_stat = NF90_PUT_VAR( id_set_xy(av),                &
+                                              id_var_do2d(av,if),           &
+                                             local_2d(nxl:nxr+1,nys:nyn+1), &
+                            start = (/ 1, 1, is, do2d_xy_time_count(av) /), &
+                                           count = (/ nx+2, ny+2, 1, 1 /) )
                    ENDIF
-#if defined( __netcdf )
-                   IF ( netcdf_output )  THEN
-                      IF ( two_d ) THEN
-                         nc_stat = NF90_PUT_VAR( id_set_xy(av),                &
-                                                 id_var_do2d(av,if),           &
-                                                local_2d(nxl:nxr+1,nys:nyn+1), &
-                                start = (/ 1, 1, 1, do2d_xy_time_count(av) /), &
-                                              count = (/ nx+2, ny+2, 1, 1 /) )
-                      ELSE
-                         nc_stat = NF90_PUT_VAR( id_set_xy(av),                &
-                                                 id_var_do2d(av,if),           &
-                                                local_2d(nxl:nxr+1,nys:nyn+1), &
-                               start = (/ 1, 1, is, do2d_xy_time_count(av) /), &
-                                              count = (/ nx+2, ny+2, 1, 1 /) )
-                      ENDIF
-                      CALL handle_netcdf_error( 'data_output_2d', 447 )
-                   ENDIF
+                   CALL handle_netcdf_error( 'data_output_2d', 447 )
 #endif
 #endif
                    do2d_xy_n = do2d_xy_n + 1
-!
-!--                Write LOCAL parameter set for ISO2D.
-                   IF ( myid == 0  .AND.  iso2d_output )  THEN
-                      IF ( section(is,s) /= -1 )  THEN
-                         WRITE ( section_chr, '(''z = '',F7.2,'' m  (GP '',I3, &
-                                               &'')'')'                        &
-                               )  level_z(layer_xy), layer_xy
-                      ELSE
-                         section_chr = 'averaged along z'
-                      ENDIF
-                      IF ( av == 0 )  THEN
-                         rtext = TRIM( do2d(av,if) ) // '  t = ' //            &
-                                 TRIM( simulated_time_chr ) // '  ' //         &
-                                 TRIM( section_chr )
-                      ELSE
-                         rtext = TRIM( do2d(av,if) ) // '  averaged t = ' //   &
-                                 TRIM( simulated_time_chr ) // '  ' //         &
-                                 TRIM( section_chr )
-                      ENDIF
-                      WRITE (27,LOCAL)
-                   ENDIF
 !
 !--                For 2D-arrays (e.g. u*) only one cross-section is available.
@@ -1104,6 +1066,6 @@
                       do2d_xz_last_time(av)  = simulated_time
                       IF ( myid == 0 )  THEN
-                         IF ( ( .NOT. data_output_2d_on_each_pe  .AND.         &
-                              netcdf_output )  .OR.  netcdf_data_format > 4 )  &
+                         IF ( .NOT. data_output_2d_on_each_pe  &
+                              .OR.  netcdf_data_format > 4 )   &
                          THEN
 #if defined( __netcdf )
@@ -1162,5 +1124,5 @@
 
 #if defined( __parallel )
-                   IF ( netcdf_output  .AND.  netcdf_data_format > 4 )  THEN
+                   IF ( netcdf_data_format > 4 )  THEN
 !
 !--                   Output in netCDF4/HDF5 format.
@@ -1192,5 +1154,5 @@
 !--                      index values.
 #if defined( __netcdf )
-                         IF ( netcdf_output  .AND.  myid == 0 )  THEN
+                         IF ( myid == 0 )  THEN
                             WRITE ( 22 )  time_since_reference_point,          &
                                           do2d_xz_time_count(av), av
@@ -1258,9 +1220,4 @@
                             ENDDO
 !
-!--                         Output of the total cross-section.
-                            IF ( iso2d_output )  THEN
-                               WRITE (22)  total_2d(-nbgp:nx+nbgp,nzb:nzt+1)
-                            ENDIF
-!
 !--                         Relocate the local array for the next loop increment
                             DEALLOCATE( local_2d )
@@ -1268,12 +1225,10 @@
 
 #if defined( __netcdf )
-                            IF ( netcdf_output )  THEN
-                               nc_stat = NF90_PUT_VAR( id_set_xz(av),          &
-                                                    id_var_do2d(av,if),        &
-                                                    total_2d(0:nx+1,nzb:nzt+1),&
-                               start = (/ 1, is, 1, do2d_xz_time_count(av) /), &
-                                                count = (/ nx+2, 1, nz+2, 1 /) )
-                               CALL handle_netcdf_error( 'data_output_2d', 58 )
-                            ENDIF
+                            nc_stat = NF90_PUT_VAR( id_set_xz(av),          &
+                                                 id_var_do2d(av,if),        &
+                                                 total_2d(0:nx+1,nzb:nzt+1),&
+                            start = (/ 1, is, 1, do2d_xz_time_count(av) /), &
+                                             count = (/ nx+2, 1, nz+2, 1 /) )
+                            CALL handle_netcdf_error( 'data_output_2d', 58 )
 #endif
 
@@ -1310,40 +1265,14 @@
                    ENDIF
 #else
-                   IF ( iso2d_output )  THEN
-                      WRITE (22)  local_2d(nxl:nxr+1,nzb:nzt+1)
-                   ENDIF
 #if defined( __netcdf )
-                   IF ( netcdf_output )  THEN
-                      nc_stat = NF90_PUT_VAR( id_set_xz(av),                   &
-                                              id_var_do2d(av,if),              &
-                                              local_2d(nxl:nxr+1,nzb:nzt+1),   &
-                               start = (/ 1, is, 1, do2d_xz_time_count(av) /), &
-                                              count = (/ nx+2, 1, nz+2, 1 /) )
-                      CALL handle_netcdf_error( 'data_output_2d', 451 )
-                   ENDIF
+                   nc_stat = NF90_PUT_VAR( id_set_xz(av),                   &
+                                           id_var_do2d(av,if),              &
+                                           local_2d(nxl:nxr+1,nzb:nzt+1),   &
+                            start = (/ 1, is, 1, do2d_xz_time_count(av) /), &
+                                           count = (/ nx+2, 1, nz+2, 1 /) )
+                   CALL handle_netcdf_error( 'data_output_2d', 451 )
 #endif
 #endif
                    do2d_xz_n = do2d_xz_n + 1
-!
-!--                Write LOCAL-parameter set for ISO2D.
-                   IF ( myid == 0  .AND.  iso2d_output )  THEN
-                      IF ( section(is,s) /= -1 )  THEN
-                         WRITE ( section_chr, '(''y = '',F8.2,'' m  (GP '',I3, &
-                                               &'')'')'                        &
-                               )  section(is,s)*dy, section(is,s)
-                      ELSE
-                         section_chr = 'averaged along y'
-                      ENDIF
-                      IF ( av == 0 )  THEN
-                         rtext = TRIM( do2d(av,if) ) // '  t = ' //            &
-                                 TRIM( simulated_time_chr ) // '  ' //         &
-                                 TRIM( section_chr )
-                      ELSE
-                         rtext = TRIM( do2d(av,if) ) // '  averaged t = ' //   &
-                                 TRIM( simulated_time_chr ) // '  ' //         &
-                                 TRIM( section_chr )
-                      ENDIF
-                      WRITE (28,LOCAL)
-                   ENDIF
 
                 CASE ( 'yz' )
@@ -1356,6 +1285,6 @@
                       do2d_yz_last_time(av)  = simulated_time
                       IF ( myid == 0 )  THEN
-                         IF ( ( .NOT. data_output_2d_on_each_pe  .AND.         &
-                              netcdf_output )  .OR.  netcdf_data_format > 4 )  &
+                         IF ( .NOT. data_output_2d_on_each_pe  &
+                              .OR.  netcdf_data_format > 4 )   &
                          THEN
 #if defined( __netcdf )
@@ -1414,5 +1343,5 @@
 
 #if defined( __parallel )
-                   IF ( netcdf_output  .AND.  netcdf_data_format > 4 )  THEN
+                   IF ( netcdf_data_format > 4 )  THEN
 !
 !--                   Output in netCDF4/HDF5 format.
@@ -1444,5 +1373,5 @@
 !--                      index values.
 #if defined( __netcdf )
-                         IF ( netcdf_output  .AND.  myid == 0 )  THEN
+                         IF ( myid == 0 )  THEN
                             WRITE ( 23 )  time_since_reference_point,          &
                                           do2d_yz_time_count(av), av
@@ -1510,9 +1439,4 @@
                             ENDDO
 !
-!--                         Output of the total cross-section.
-                            IF ( iso2d_output )  THEN
-                               WRITE (23)  total_2d(0:ny+1,nzb:nzt+1)
-                            ENDIF
-!
 !--                         Relocate the local array for the next loop increment
                             DEALLOCATE( local_2d )
@@ -1520,12 +1444,10 @@
 
 #if defined( __netcdf )
-                            IF ( netcdf_output )  THEN
-                               nc_stat = NF90_PUT_VAR( id_set_yz(av),          &
-                                                    id_var_do2d(av,if),        &
-                                                    total_2d(0:ny+1,nzb:nzt+1),&
-                               start = (/ is, 1, 1, do2d_yz_time_count(av) /), &
-                                                count = (/ 1, ny+2, nz+2, 1 /) )
-                               CALL handle_netcdf_error( 'data_output_2d', 61 )
-                            ENDIF
+                            nc_stat = NF90_PUT_VAR( id_set_yz(av),          &
+                                                 id_var_do2d(av,if),        &
+                                                 total_2d(0:ny+1,nzb:nzt+1),&
+                            start = (/ is, 1, 1, do2d_yz_time_count(av) /), &
+                                             count = (/ 1, ny+2, nz+2, 1 /) )
+                            CALL handle_netcdf_error( 'data_output_2d', 61 )
 #endif
 
@@ -1562,40 +1484,14 @@
                    ENDIF
 #else
-                   IF ( iso2d_output )  THEN
-                      WRITE (23)  local_2d(nys:nyn+1,nzb:nzt+1)
-                   ENDIF
 #if defined( __netcdf )
-                   IF ( netcdf_output )  THEN
-                      nc_stat = NF90_PUT_VAR( id_set_yz(av),                   &
-                                              id_var_do2d(av,if),              &
-                                              local_2d(nys:nyn+1,nzb:nzt+1),   &
-                               start = (/ is, 1, 1, do2d_xz_time_count(av) /), &
-                                              count = (/ 1, ny+2, nz+2, 1 /) )
-                      CALL handle_netcdf_error( 'data_output_2d', 452 )
-                   ENDIF
+                   nc_stat = NF90_PUT_VAR( id_set_yz(av),                   &
+                                           id_var_do2d(av,if),              &
+                                           local_2d(nys:nyn+1,nzb:nzt+1),   &
+                            start = (/ is, 1, 1, do2d_xz_time_count(av) /), &
+                                           count = (/ 1, ny+2, nz+2, 1 /) )
+                   CALL handle_netcdf_error( 'data_output_2d', 452 )
 #endif
 #endif
                    do2d_yz_n = do2d_yz_n + 1
-!
-!--                Write LOCAL-parameter set for ISO2D.
-                   IF ( myid == 0  .AND.  iso2d_output )  THEN
-                      IF ( section(is,s) /= -1 )  THEN
-                         WRITE ( section_chr, '(''x = '',F8.2,'' m  (GP '',I3, &
-                                               &'')'')'                        &
-                               )  section(is,s)*dx, section(is,s)
-                      ELSE
-                         section_chr = 'averaged along x'
-                      ENDIF
-                      IF ( av == 0 )  THEN
-                         rtext = TRIM( do2d(av,if) ) // '  t = ' //            &
-                                 TRIM( simulated_time_chr ) // '  ' //         &
-                                 TRIM( section_chr )
-                      ELSE
-                         rtext = TRIM( do2d(av,if) ) // '  averaged t = ' //   &
-                                 TRIM( simulated_time_chr ) // '  ' //         &
-                                 TRIM( section_chr )
-                      ENDIF
-                      WRITE (29,LOCAL)
-                   ENDIF
 
              END SELECT
@@ -1609,5 +1505,5 @@
 !--       the performance of the parallel output.
 #if defined( __netcdf )
-          IF ( netcdf_output .AND. netcdf_data_format > 4 )  THEN
+          IF ( netcdf_data_format > 4 )  THEN
 
                 SELECT CASE ( mode )
Index: /palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_3d.f90	(revision 1326)
+++ /palm/trunk/SOURCE/data_output_3d.f90	(revision 1327)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! parts concerning avs output removed,
+! -netcdf output queries
 !
 ! Former revisions:
@@ -87,7 +88,7 @@
         
     USE control_parameters,                                                    &
-        ONLY:  avs_data_file,avs_output, cloud_physics, do3d, do3d_avs_n,      &
-               do3d_compress, do3d_no, do3d_time_count, io_blocks, io_group,   &
-               message_string, netcdf_output, netcdf_data_format, ntdim_3d,    &
+        ONLY:  avs_data_file, cloud_physics, do3d, do3d_avs_n,                 &
+               do3d_no, do3d_time_count, io_blocks, io_group,                  &
+               message_string, netcdf_data_format, ntdim_3d,                   &
                nz_do3d, plot_3d_precision, psolver, simulated_time,            &
                simulated_time_chr, skip_do_avs, time_since_reference_point
@@ -164,13 +165,9 @@
 !-- and/or avs).
 !-- For netCDF4/HDF5 output, data is written in parallel into one file.
-    IF ( netcdf_output )  THEN
-       IF ( netcdf_data_format < 5 )  THEN
-          CALL check_open( 30 )
-          IF ( myid == 0 )  CALL check_open( 106+av*10 )
-       ELSE
-          CALL check_open( 106+av*10 )
-       ENDIF
+    IF ( netcdf_data_format < 5 )  THEN
+       CALL check_open( 30 )
+       IF ( myid == 0 )  CALL check_open( 106+av*10 )
     ELSE
-       IF ( avs_output  .OR.  ( numprocs > 1 ) )  CALL check_open( 30 )
+       CALL check_open( 106+av*10 )
     ENDIF
 
@@ -186,11 +183,9 @@
     do3d_time_count(av) = do3d_time_count(av) + 1
     IF ( myid == 0 )  THEN
-       IF ( netcdf_output )  THEN
-          nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_time_3d(av),           &
-                                  (/ time_since_reference_point /),            &
-                                  start = (/ do3d_time_count(av) /),           &
-                                  count = (/ 1 /) )
-          CALL handle_netcdf_error( 'data_output_3d', 376 )
-       ENDIF
+       nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_time_3d(av),           &
+                               (/ time_since_reference_point /),            &
+                               start = (/ do3d_time_count(av) /),           &
+                               count = (/ 1 /) )
+       CALL handle_netcdf_error( 'data_output_3d', 376 )
     ENDIF
 #endif
@@ -201,15 +196,4 @@
 
     DO  WHILE ( do3d(av,if)(1:1) /= ' ' )
-!
-!--    Set the precision for data compression.
-       IF ( do3d_compress )  THEN
-          DO  i = 1, 100
-             IF ( plot_3d_precision(i)%variable == do3d(av,if) )  THEN
-                prec = plot_3d_precision(i)%precision
-                EXIT
-             ENDIF
-          ENDDO
-       ENDIF
-
 !
 !--    Store the array chosen on the temporary array.
@@ -504,112 +488,64 @@
 
 !
-!--    Output of the volume data information for the AVS-FLD-file.
-       do3d_avs_n = do3d_avs_n + 1
-       IF ( myid == 0  .AND.  avs_output )  THEN
-!
-!--       AVS-labels must not contain any colons. Hence they must be removed
-!--       from the time character string.
-          simulated_time_mod = simulated_time_chr
-          DO  WHILE ( SCAN( simulated_time_mod, ':' ) /= 0 )
-             pos = SCAN( simulated_time_mod, ':' )
-             simulated_time_mod(pos:pos) = '/'
+!--    Output of the 3D-array
+#if defined( __parallel )
+       IF ( netcdf_data_format < 5 )  THEN
+!
+!--       Non-parallel netCDF output. Data is output in parallel in
+!--       FORTRAN binary format here, and later collected into one file by
+!--       combine_plot_fields
+          IF ( myid == 0 )  THEN
+             WRITE ( 30 )  time_since_reference_point,                   &
+                           do3d_time_count(av), av
+          ENDIF
+          DO  i = 0, io_blocks-1
+             IF ( i == io_group )  THEN
+                WRITE ( 30 )  nxlg, nxrg, nysg, nyng, nzb, nz_do3d
+                WRITE ( 30 )  local_pf
+             ENDIF
+#if defined( __parallel )
+             CALL MPI_BARRIER( comm2d, ierr )
+#endif
           ENDDO
 
-          IF ( av == 0 )  THEN
-             WRITE ( 33, 3300 )  do3d_avs_n, TRIM( avs_data_file ),            &
-                                 skip_do_avs, TRIM( do3d(av,if) ),             &
-                                 TRIM( simulated_time_mod )
+       ELSE
+#if defined( __netcdf )
+!
+!--       Parallel output in netCDF4/HDF5 format.
+!--       Do not output redundant ghost point data except for the
+!--       boundaries of the total domain.
+          IF ( nxr == nx  .AND.  nyn /= ny )  THEN
+             nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),  &
+                               local_pf(nxl:nxr+1,nys:nyn,nzb:nz_do3d),  &
+                start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /),  &
+                count = (/ nxr-nxl+2, nyn-nys+1, nz_do3d-nzb+1, 1 /) )
+          ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
+             nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),  &
+                               local_pf(nxl:nxr,nys:nyn+1,nzb:nz_do3d),  &
+                start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /),  &
+                count = (/ nxr-nxl+1, nyn-nys+2, nz_do3d-nzb+1, 1 /) )
+          ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
+             nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),  &
+                             local_pf(nxl:nxr+1,nys:nyn+1,nzb:nz_do3d),  &
+                start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /),  &
+                count = (/ nxr-nxl+2, nyn-nys+2, nz_do3d-nzb+1, 1 /) )
           ELSE
-             WRITE ( 33, 3300 )  do3d_avs_n, TRIM( avs_data_file ),            &
-                                 skip_do_avs, TRIM( do3d(av,if) ) //           &
-                                 ' averaged', TRIM( simulated_time_mod )
+             nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),  &
+                                 local_pf(nxl:nxr,nys:nyn,nzb:nz_do3d),  &
+                start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /),  &
+                count = (/ nxr-nxl+1, nyn-nys+1, nz_do3d-nzb+1, 1 /) )
           ENDIF
-!
-!--       Determine the Skip-value for the next array. Record end and start 
-!--       require 4 byte each.
-          skip_do_avs = skip_do_avs + ( ( ( nx+2*nbgp ) * ( ny+2*nbgp ) *      &
-                                          ( nz_do3d+1 ) ) * 4 + 8 )
+          CALL handle_netcdf_error( 'data_output_3d', 386 )
+#endif
        ENDIF
-
-!
-!--    Output of the 3D-array. (compressed/uncompressed)
-       IF ( do3d_compress )  THEN
-!
-!--       Compression, output of compression information on FLD-file and output
-!--       of compressed data.
-          CALL write_compressed( local_pf, 30, 33, myid, nxl, nxr, nyn, nys,   &
-                                 nzb, nz_do3d, prec, nbgp )
-       ELSE
-!
-!--       Uncompressed output.
-#if defined( __parallel )
-          IF ( netcdf_output )  THEN
-             IF ( netcdf_data_format < 5 )  THEN
-!
-!--             Non-parallel netCDF output. Data is output in parallel in
-!--             FORTRAN binary format here, and later collected into one file by
-!--             combine_plot_fields
-                IF ( myid == 0 )  THEN
-                   WRITE ( 30 )  time_since_reference_point,                   &
-                                 do3d_time_count(av), av
-                ENDIF
-                DO  i = 0, io_blocks-1
-                   IF ( i == io_group )  THEN
-                      WRITE ( 30 )  nxlg, nxrg, nysg, nyng, nzb, nz_do3d
-                      WRITE ( 30 )  local_pf
-                   ENDIF
-#if defined( __parallel )
-                   CALL MPI_BARRIER( comm2d, ierr )
-#endif
-                ENDDO
-
-             ELSE
+#else
 #if defined( __netcdf )
-!
-!--             Parallel output in netCDF4/HDF5 format.
-!--             Do not output redundant ghost point data except for the
-!--             boundaries of the total domain.
-                IF ( nxr == nx  .AND.  nyn /= ny )  THEN
-                   nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),  &
-                                     local_pf(nxl:nxr+1,nys:nyn,nzb:nz_do3d),  &
-                      start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /),  &
-                      count = (/ nxr-nxl+2, nyn-nys+1, nz_do3d-nzb+1, 1 /) )
-                ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
-                   nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),  &
-                                     local_pf(nxl:nxr,nys:nyn+1,nzb:nz_do3d),  &
-                      start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /),  &
-                      count = (/ nxr-nxl+1, nyn-nys+2, nz_do3d-nzb+1, 1 /) )
-                ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
-                   nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),  &
-                                   local_pf(nxl:nxr+1,nys:nyn+1,nzb:nz_do3d),  &
-                      start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /),  &
-                      count = (/ nxr-nxl+2, nyn-nys+2, nz_do3d-nzb+1, 1 /) )
-                ELSE
-                   nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),  &
-                                       local_pf(nxl:nxr,nys:nyn,nzb:nz_do3d),  &
-                      start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /),  &
-                      count = (/ nxr-nxl+1, nyn-nys+1, nz_do3d-nzb+1, 1 /) )
-                ENDIF
-                CALL handle_netcdf_error( 'data_output_3d', 386 )
-#endif
-             ENDIF
-          ENDIF
-#else
-          IF ( avs_output )  THEN
-             WRITE ( 30 )  local_pf(nxl:nxr+1,nys:nyn+1,:)
-          ENDIF
-#if defined( __netcdf )
-          IF ( netcdf_output )  THEN
-
-             nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),        &
-                               local_pf(nxl:nxr+1,nys:nyn+1,nzb:nz_do3d),      &
-                               start = (/ 1, 1, 1, do3d_time_count(av) /),     &
-                               count = (/ nx+2, ny+2, nz_do3d-nzb+1, 1 /) )
-             CALL handle_netcdf_error( 'data_output_3d', 446 )
-
-          ENDIF
+       nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),        &
+                         local_pf(nxl:nxr+1,nys:nyn+1,nzb:nz_do3d),      &
+                         start = (/ 1, 1, 1, do3d_time_count(av) /),     &
+                         count = (/ nx+2, ny+2, nz_do3d-nzb+1, 1 /) )
+       CALL handle_netcdf_error( 'data_output_3d', 446 )
 #endif
 #endif
-       ENDIF
 
        if = if + 1
